<?PHP
// Original code from Squatty.com
// Made by Warren Parks wlparks@southern.edu
// Made for geeklog

include('config.php');

/* Taken from Chapter 11 example 10 from programming PHP 
   Modified slightly to serve our purposes.
 */
class StockParse {
  var $parser;
  var $records;
  var $record;
  var $current_field = '';
  var $field_type;
  var $ends_record;

  function StockParse ($filename) {
    $this->parser = xml_parser_create();
    xml_set_object($this->parser, &$this);
    xml_set_element_handler($this->parser, 'start_element', 'end_element');
    xml_set_character_data_handler($this->parser, 'cdata');

    // 1 = single field, 2 = array field, 3 = record container
    $this->field_type = array('title' => 1,
                              'author' => 2,
                              'isbn' => 1,
                              'comment' => 1);
    $this->ends_record = array('stock' => true);

    $x = join("", file($filename));
    $x = html_entity_decode($x); // Turn the String element into valid XML */
    xml_parse($this->parser, $x);
    xml_parser_free($this->parser);
  }

  function start_element ($p, $element, &$attributes) {
    $element = strtolower($element);
    //print("start element called element=$element\n");
      $this->current_field = $element;
  }

  function end_element ($p, $element) {
    $element = strtolower($element);
    //print("end element called element=$element\n");
    if ($this->ends_record[$element]) {
      $this->records[] = $this->record;
      $this->record = array();
    }
    $this->current_field = '';
  }

  function cdata ($p, $text) {
	  //print("cdata called text=$text\n");
	  $this->record[$this->current_field] .= $text;
  }
}

### Socket Functions

function get_stock($stock) {
	/* Old code that doesnt work */
    /*$webpage = fopen("http://www.webservicex.net/stockquote.asmx/GetQuote?symbol=" . $stock, "r");
    $line = strip_tags(fread($webpage, 2550));
    $search = array ('&lt;StockQuotes&gt;&lt;Stock&gt;&lt;Symbol&gt;', '&lt;/Symbol&gt;&lt;Last&gt;',
        '&lt;/Last&gt;&lt;Date&gt;', '&lt;/Date&gt;&lt;Time&gt;', 
        '&lt;/Time&gt;&lt;Change&gt;', '&lt;/Change&gt;&lt;Open&gt;', 
        '&lt;/Open&gt;&lt;High&gt;', '&lt;/High&gt;&lt;Low&gt;', 
        '&lt;/Low&gt;&lt;Volume&gt;', '&lt;/Volume&gt;&lt;MktCap&gt;',
        '&lt;/MktCap&gt;&lt;PreviousClose&gt;', '&lt;/PreviousClose&gt;&lt;PercentageChange&gt;',
        '&lt;/PercentageChange&gt;&lt;AnnRange&gt;', '&lt;/AnnRange&gt;&lt;Earns&gt;',
        '&lt;/Earns&gt;&lt;P-E&gt;', '&lt;/P-E&gt;&lt;Name&gt;', 
        '&lt;/Name&gt;&lt;/Stock&gt;&lt;/StockQuotes&gt;');
    $replace = array ("", ",", ",", ",", ",", ",", ",", ",", ",", ",", ",", ",", ",",
        ",", ",", ",", ""); */

	/* Parse XML using the xml routines */
	$parser = new StockParse("http://www.webservicex.net/stockquote.asmx/GetQuote?symbol=" . $stock);
	$rec = $parser->records[0];
	$list = array($rec['symbol'],$rec['last'],$rec['date'],$rec['time'],$rec['change'],
			$rec['open'],$rec['high'],$rec['low'],$rec['volume'],$rec['mktcap'],
			$rec['previousclose'],$rec['percentchange'],$rec['annrange'],$rec['earns'],
			$rec['p-e'],$rec['name']);
    
    /*$list = array('Symbol', 'Last', 'Date', 'Time', 'Change', 'Open', 'High', 'Low', 'Volume', 
        'MktCap', 'PreviousClose', 'PercentageChange', 'AnnRange', 'Earns', 'P-E', 'Name')*/
 
//    fclose($webpage);
//    return explode(",", str_replace($search, $replace, $line));
	return $list;
          
}


/* This function takes no arguments and returns the stocks in 
an array. */

function st_grab_user_stocks($user = false, $beenhere = false) {
    require_once('config.php');
    global $_CONF, $_USER, $_TABLES, $ST, $delay;
    
    if ($user == false && isset($_USER['uid'])) // your logged in
    {
        $user = $_USER['uid'];
    } else { // Your anonymous
        $user = 1;
    }
    $query = "SELECT DISTINCT ST_short, ST_total, ST_change, 
                              ST_timestamp, ST_stocks.ST_ID
              FROM ST_stocks INNER JOIN ST_user_stocks ON ST_stocks.ST_ID = ST_user_stocks.ST_ID 
              WHERE uid = '$user'";
              /*ORDER BY ST_user_stocks.ST_ID ASC";*/
    $result = DB_query($query);
    $stocks = "";
   
    $sT = new Template($_CONF['path'] . 'plugins/stocks/templates');
    $sT->set_file(array('blocklist'=>'blocklist.thtml', 'row'=>'blockrow.thtml', 
        'in'=>'blockloggedin.thtml'));
    $sT->set_var('url', $_CONF['site_url'] . "/stocks/quote.php");
    $sT->set_var('delay', $delay);
    $sT->set_var('edit_url', $_CONF['site_url'] . "/stocks/edit.php");                   
    for ($h = 0; $row = DB_fetchArray($result); $h++){
        $row = check_date($row);
        // This is the filter for stock names
        $sT->set_var('stock', str_replace($ST['symbol'], $ST['replace'], $row[0]));
        $sT->set_var('symbol', $row[0]);
        $sT->set_var('total', number_format($row[1], 2));
        if ($row[2] < 0) {
            $sT->set_var('color', $ST['negative']);
            $sT->set_var('position', '');
        } else {
            $sT->set_var('color', $ST['positive']);
            $sT->set_var('position', '+');
        }
        $sT->set_var('change', number_format($row[2], 2));
        $sT->parse('stockrow', 'row', true);
    } 
    // if you don't have any stock options, your going to get the default.
    if ($h == 0 && $beenhere != true) {
        grab_default_stocks($_USER['uid']);
        $beenhere = true;
        return st_grab_user_stocks(false,$beenhere); 
    }
    if ($_USER['uid'] > 1) { // show edit screen if logged in
        $sT->parse('loggedin', 'in', true); 
    }
    $sT->parse('output', 'blocklist');
    $output = $sT->finish($sT->get_var('output'));
    return $output;
    
    /*  $stocks[$h]['short']  = $row[0];
        $stocks[$h]['total']  = $row[1];
        $stocks[$h]['change'] = $row[2];
        $stocks[$h]['date']   = $row[3];
        $stocks[$h]['st_id']  = $row[4];  */
}
   
function grab_default_stocks($user) {
    $query = "SELECT DISTINCT ST_stocks.ST_ID
              FROM ST_stocks INNER JOIN ST_user_stocks ON ST_stocks.ST_ID = ST_user_stocks.ST_ID 
              WHERE uid = '1' 
              ORDER BY ST_user_stocks.ST_ID ASC";
    $result = DB_query($query);
    for ($h = 0; $row = DB_fetchArray($result); $h++){
        $query2 = "INSERT INTO ST_user_stocks (uid, ST_ID)
                    VALUES ('$user', '{$row[0]}')";
        $result2 = DB_query($query2);
    }
}
    
    
    
function check_date($timestamp) {
    include('config.php');
    /*echo $timestamp[3] . "<";
    echo "<b>" . date("YmdGis", strtotime("-" . $delay . " minutes")) . "</b><br>";*/
    if ($timestamp[3] < date("YmdGis", strtotime("-" . $delay . " minutes"))){
        $updated = update_stock(get_stock($timestamp[0]), $timestamp[4]);
        $timestamp[2] = $updated[1]; // change
        $timestamp[1] = $updated[0]; // total
        return $timestamp;
    }
    else {
        return $timestamp;       
    }
    /* 
    
0'Symbol', 1'Last', 2'Date', 3'Time', 4'Change', 5'Open', 6'High', 7'Low', 8'Volume', 
9'MktCap', 10'PreviousClose', 11'PercentageChange', 12'AnnRange', 13'Earns', 14'P-E', 15'Name
        
       */
}

function update_stock($updatedstock, $stockID) {
    $query = "UPDATE ST_stocks 
              SET ST_total='" . $updatedstock[1] . "',
                  ST_long = '" . $updatedstock[15] . "',
                  ST_change='" . $updatedstock[4] . "', 
                  ST_timestamp=NOW(),
                  ST_Open = '" . $updatedstock[5] . "',
                  ST_High = '" . $updatedstock[6] . "',
                  ST_Low = '" . $updatedstock[7] . "',
                  ST_Volume = '" . $updatedstock[8] . "',
                  ST_MktCap = '" . $updatedstock[9] . "',
                  ST_PreviousClose = '" . $updatedstock[10] . "',
                  ST_PercentageChange = '" . $updatedstock[11] . "',
                  ST_AnnRange = '" . $updatedstock[12] . "',
                  ST_Earns = '" . $updatedstock[13] . "',
                  ST_stocks.ST_PE = '" . $updatedstock[14] . "'
              WHERE ST_ID='" . $stockID . "'";
    //echo $query;
    $result = DB_query($query);
    $updated[0] = $updatedstock[1]; // total
    $updated[1] = $updatedstock[4]; // change
    
    return $updated;
    
}

function watchlist($uid, $where = 'edit.php') {
    global $_CONF;
    if ($where == 'admin')
    {
        $where = 'index.php';
    }
    $query = "SELECT    ST_stocks.ST_short, ST_user_stocks.ST_USER_ID, ST_stocks.ST_long
              FROM      ST_user_stocks INNER JOIN
                        ST_stocks ON ST_user_stocks.ST_ID = ST_stocks.ST_ID
              WHERE     (ST_user_stocks.uid = " . $uid . ")";

    $result = DB_query($query);
    
    if (mysql_num_rows($result) == 0) {
        grab_default_stocks($uid);
        $query = "SELECT    ST_stocks.ST_short, ST_user_stocks.ST_USER_ID, ST_stocks.ST_long
              FROM      ST_user_stocks INNER JOIN
                        ST_stocks ON ST_user_stocks.ST_ID = ST_stocks.ST_ID
              WHERE     (ST_user_stocks.uid = " . $uid . ")";

        $result = DB_query($query);
    }
    $wT = new Template($_CONF['path'] . 'plugins/stocks/templates');
    $wT->set_file(array('watchlist'=>'watchlist.thtml', 'row'=>'watchrow.thtml'));
                            
    while($row = DB_fetchArray($result)) {
        $wT->set_var('short', $row[0]);
        $wT->set_var('long', $row[2]);
        $wT->set_var('id', $row[1]);
        $wT->set_var('where', $where);
        $wT->parse('stockrow', 'row', true);
    }
    $wT->parse('output', 'watchlist');
    return $wT->finish($wT->get_var('output'));
   
}

function addoption($option, $user) {
    
    // This section checks to see if its an actual symbol
    $open = fopen("http://quote.yahoo.com/d/quotes.csv?f=sl1d1t1c1ohgv&e=.csv&s=$option", "r");
 $read = fread($open, 2000);
 fclose($open);

 $read = str_replace("\"", "", $read);
 $read = explode(",", $read);

 if ($read[1] == 0) {
     return "<font color=\"red\">The symbol you provided <b>" . $option . " </b>does not appear to be 
     a valid stock symbol.</font>";
 }
    else { // this is what happens if its not
        $query = "SELECT COUNT(*) FROM ST_stocks WHERE ST_stocks.ST_short ='" . $option . "'";
        $result = DB_query($query);
        $row = DB_fetchArray($result);
        if ($row[0] < 1) {
            include('config.php');
            $delay = $delay + 10;
            $date = date("YmdGis", strtotime("-" . $delay . " minutes"));
            $query = "INSERT 
                   INTO ST_stocks (ST_short, ST_timestamp)
                      VALUES ('" . $option . "', '" . $date . "')";
         $result = DB_query($query);
         $query = "SELECT ST_short, ST_total, ST_change, 
                       ST_timestamp, ST_stocks.ST_ID 
                   FROM ST_stocks
                      WHERE (ST_short ='" . $option . "')";
            $result = DB_query($query);
            $row = DB_fetchArray($result);
            $row = check_date($row); 
        }
     $query = "SELECT ST_short, ST_total, ST_change, 
                   ST_timestamp, ST_stocks.ST_ID 
               FROM ST_stocks
               WHERE (ST_short ='" . $option . "')";
     $result = DB_query($query);
      
      
        $row = DB_fetchArray($result);
     $query = "INSERT
               INTO ST_user_stocks (uid, ST_ID)
               VALUES ('" . $user . "', '" . $row[4] . "')";
     $result = DB_query($query);
    }
}

?>
